	# Revision history for hanabi-dealer

	## 0.7.2.0 -- 2020-04-02

	* make SimpleStrategy less stupid, more fun to play with

	* introduce some utility functions with which to build strategies

	* consider viewport when rendering the GUI frontend

	## 0.7.1.1 -- 2020-03-13

	* remove reference to a not-publicly-available strategy

	## 0.7.1.0 -- 2020-03-13

	* fix freeze after invalid move when played locally

	* improve the menu GUI for rules and verbosity

	* fix problems related to the 6th-color

	* slightly substantiate the function set for implementing strategies

	* slightly improve SimpleStrategy

	## 0.7.0.0 -- 2020-02-28

	* start games locally when possible.

	* make the observation mode report interactions.

	* introduce the earlyQuit rule option, where the game is called when the best possible score (which can be below 25) is achieved.

	* introduce currentScore and achievedScore.

	* add lots of bells and whistles to the front end.

	## 0.6.0.0 -- 2020-02-08

	* introduce the observation (or audience) mode

	* rename the command names from server and client to hanabib and hanabif respectively.

	* Flag jsaddle builds hanabiq that is quickly-built executable including the functionalities of both hanabib and hanabif (but it is not stable.)

	## 0.5.0.0 -- 2020-02-05

	* implement possibility marks which represent what colors and what numbers are possible for each card

	* introduce utility functions using the information of possibilities, and redesign the set of utilities

	* implement isDoubleDrop and warnDoubleDrop

	* enable customizing verbosity from the client

	* support Warp as the WebSocket server

	* add the jsaddle flag

	## 0.4.0.1 -- 2020-01-29

	* fix the bug of the endgame behavior that crept in during the switch to 0.4.0.0

	* adjust the screen for creating a game

	## 0.4.0.0 -- 2020-01-28

	* improve GUI

	* enable starting games from anyone, and shuffling the player list

	* actually implement the prolong option

	* enable finding chop cards

	* enable finding obviously-useless cards from the hints

	* enable finding obviously-playable cards from the hints

	* change the definition of invisibleBag to consider fully-hinted cards, too

	* define some other utility functions

	## 0.3.2.0 -- 2020-01-16

	* make the server and the client parts of the library

	* make other strategies selectable from the client, and make SimpleStrategy the first of such strategies

	* roll back memoization to fix some problem

	## 0.3.1.0 -- 2020-01-14

	* introduce StrategyDict, dictionary-style interface to Strategy

	* reflect the -p option

	* resolve the name collision against websockets-0.12.7.0

	## 0.3.0.1 -- 2020-01-12

	* fix bestPossibleRank (and thus isUseless)

	## 0.3.0.0 -- 2020-01-12

	* playable client/server system via WebSocket

	* GUI using GHCJS and Miso

	* separate invisibleBag from PrivateView

	* surpress redundant broadcasting of the observation to the current player

	* add SimpleStrategy example

	## 0.2.1.0 -- 2020-01-04

	* introduce isPlayable

	* fix several misfeatures

	## 0.2.0.0 -- 2019-12-20

	* define the Verbosity option

	* confirm running with base-4.13 compiled by GHC-8.8.1.

	## 0.1.0.0 -- 2019-12-18

	* First version. Released on an unsuspecting world.
